Type line
	Field x1, y1, x2, y2
	Field a_x1, a_y1, a_x2, a_y2
	Field min_x1, min_y1, min_x2, min_y2
	Field max_x1, max_y1, max_x2, max_y2
	Field ID	' 0 = gehoert zu nichts
	Field moving
	
	Method move()
		x1 = x1 + a_x1
		y1 = y1 + a_y1
		x2 = x2 + a_x2
		y2 = y2 + a_y2
		If x1 < min_x1 Or x1 > max_x1 Then a_x1 = -(a_x1)
		If y1 < min_y1 Or y1 > max_y1 Then a_y1 = -(a_y1)
		If x2 < min_x2 Or x2 > max_x2 Then a_x2 = -(a_x2)
		If y2 < min_y2 Or y2 > max_y2 Then a_y2 = -(a_y2)
	End Method
	
	Method draw()
		SetColor 255,255,255
		DrawLine x1, y1, x2, y2
	End Method
End Type

Global line_list:TList = CreateList()


Type circle
	Field x, y, r
	Field a_x, a_y, a_r
	Field min_x, min_y, min_r
	Field max_x, max_y, max_r
	Field ID	' 0 = gehoert zu nichts
	Field moving
	
	Method move()
		x = x + a_x
		y = y + a_y
		r = r + a_r
		If x < min_x Or x > max_x Then a_x = -(a_x)
		If y < min_y Or y > max_y Then a_y = -(a_y)
		If r < min_r Or r > max_r Then a_r = -(a_r)
	End Method
		
	Method draw()
		DrawOval x - r, y - r, r*2, r*2
		SetColor 0,0,0
		DrawOval x-r+1, y-r+1, r*2-2, r*2-2
		SetColor 255,255,255
	End Method
End Type

Global circle_list:TList = CreateList()


Type wheel
	Field angle
	Field a_angle
	Field c_lines
	Field l_lines
	Field ID
	Field moving
	
	Method AnglePlus()
		angle = angle + a_angle
	End Method
	
	Method turn()
		For c:circle = EachIn circle_list
			If c.ID = Self.ID Then nx = c.x ; ny = c.y ; nr = c.r ; Exit
		Next
		q = 0
		For l:line = EachIn line_list
			If l.ID = Self.ID Then
				l.x1 = nx-Cos(angle + 360/c_lines*q)*nr
				l.y1 = ny+Sin(angle + 360/c_lines*q)*nr
				l.x2 = nx-Cos(angle + 360/c_lines*q)*(nr+l_lines)
				l.y2 = ny+Sin(angle + 360/c_lines*q)*(nr+l_lines)
			End If
			q = q + 1
		Next
	End Method
End Type

Global wheel_list:TList = CreateList()


Type switch
	Field x, y
	Field ID
	Field enabled
	
	Method enable()
		enabled = 1
		For l:line = EachIn line_list
			If l.ID = Self.ID Then l.moving = 1
		Next
		For c:circle = EachIn circle_list
			If c.ID = Self.ID Then c.moving = 1
		Next
		For w:wheel = EachIn wheel_list
			If w.ID = Self.ID Then w.moving = 1
		Next
		For s:switch = EachIn switch_list
			If s.ID = Self.ID Then s.enabled=1
		Next
	End Method
	
	Method disable()
		enabled = 0
		For l:line = EachIn line_list
			If l.ID = Self.ID Then l.moving = 0
		Next
		For c:circle = EachIn circle_list
			If c.ID = Self.ID Then c.moving = 0
		Next
		For w:wheel = EachIn wheel_list
			If w.ID = Self.ID Then w.moving = 0
		Next
		For s:switch = EachIn switch_list
			If s.ID = Self.ID Then s.enabled=0
		Next
	End Method
	
	Method togglestate()
		If enabled=1 Then disable();Else enable()
	End Method
	
	Method ctrl()
		If rectsoverlap(x,y,x+30,y+30,px,py,px+30,py+30) And mh1=1 Then togglestate()
	End Method
	
	Method draw()
		DrawImage imgswitch,x,y,1-enabled
	End Method
End Type

Global switch_list:TList = CreateList()


Global px, py
Global old_px,old_py
Global lifes
Global startx, starty
Global endx, endy
Global collided
Global mx,my,mh1
Global a_lvl
Global act_ID
Global imgswitch = LoadAnimImage("gfx\switch.bmp",30,30,0,2)
Global rabbit = LoadImage("gfx\rabbit.bmp")
Global egg = LoadImage("gfx\egg.bmp")

Global timer = CreateTimer(60)

'****************************************************************************************

Function loadline(filein,m=1)
Local l:line = New line
line_list.AddLast l

l.x1 = ReadInt(filein)
l.y1 = ReadInt(filein)
l.x2 = ReadInt(filein)
l.y2 = ReadInt(filein)
l.a_x1 = ReadInt(filein)
l.a_y1 = ReadInt(filein)
l.a_x2 = ReadInt(filein)
l.a_y2 = ReadInt(filein)
l.min_x1 = ReadInt(filein)
l.min_y1 = ReadInt(filein)
l.min_x2 = ReadInt(filein)
l.min_y2 = ReadInt(filein)
l.max_x1 = ReadInt(filein)
l.max_y1 = ReadInt(filein)
l.max_x2 = ReadInt(filein)
l.max_y2 = ReadInt(filein)
l.moving = m
End Function

Function loadcircle(filein,m=1)
Local c:circle = New circle
circle_list.AddLast c

c.x = ReadInt(filein)
c.y = ReadInt(filein)
c.r = ReadInt(filein)
c.a_x = ReadInt(filein)
c.a_y = ReadInt(filein)
c.a_r = ReadInt(filein)
c.min_x = ReadInt(filein)
c.min_y = ReadInt(filein)
c.min_r = ReadInt(filein)
c.max_x = ReadInt(filein)
c.max_y = ReadInt(filein)
c.max_r = ReadInt(filein)
c.moving = m
End Function

Function loadwheel(filein,m=1,nID=1)
If nID=1 Then act_ID = act_ID + 1

Local w:wheel = New wheel
wheel_list.AddLast w

w.a_angle = ReadInt(filein)
w.c_lines = ReadInt(filein)
w.l_lines = ReadInt(filein)
w.ID = act_ID
w.moving = m

loadcircle(filein)
Local c:circle = circle(circle_list.Last())
c.ID = w.ID

For i = 1 To w.c_lines
	Local l:line = New line
	line_list.AddLast l
	l.ID = w.ID
Next

w.turn()
End Function

Function loadswitch(filein)
act_ID = act_ID + 1

Local s:switch = New switch
switch_list.AddLast s

s.x = ReadInt(filein)
s.y = ReadInt(filein)
s.ID = act_ID

inp = ReadInt(filein)
Select inp
	Case 1
		loadline(filein,0)
		Local l:line = line(line_list.Last())
		l.ID = s.ID
	Case 2
		loadcircle(filein,0)
		Local c:circle = circle(circle_list.Last())
		c.ID = s.ID
	Case 3
		loadwheel(filein,0,0)
		Local w:wheel = wheel(wheel_list.Last())
		w.ID = s.ID
	Case 4
		act_ID=act_ID-1
		s.ID = ReadInt(filein)
		For w:wheel = EachIn wheel_list
			If w.ID = s.ID And w.moving = 1 Then s.enabled=1
		Next
End Select
End Function

Function loadlevel(nr)
	ClearList(line_list)
	ClearList(circle_list)
	ClearList(wheel_list)
	ClearList(switch_list)
	
	If nr Mod 5 = 0 Then lifes = lifes + 1
	
	act_ID = 0
	
	filein = ReadStream("levels\lvl"+nr)
	If filein = 0 Then win()
	
	startx = ReadInt(filein)
	starty = ReadInt(filein)
	endx = ReadInt(filein)
	endy = ReadInt(filein)
	
	While Not Eof(filein)
		
		inp = ReadInt(filein)
		Select inp
			Case 1
				loadline(filein)
			Case 2
				loadcircle(filein)
			Case 3
				loadwheel(filein)
			Case 4
				loadswitch(filein)
		End Select
		
	Wend
	
	CloseStream filein
	
	px = startx
	py = starty
	old_px = px
	old_py = py
	MoveMouse(px,py)
	
End Function

Function LinesCollide(x1#,y1#,x2#,y2#,x3#,y3#,x4#,y4#)
If x1=x2 And x3=x4 And x1=x3 And Min(y1,y2)<=Max(y3,y4) And Max(y1,y2)>=Min(y3,y4) Then Return 1
If x1=x2 And y3=y4 And x1>=Min(x3,x4) And x1<=Max(x3,x4) And Min(y1,y2)<=y3 And Max(y1,y2)=>y3 Then Return 1
If x3=x4 And y1=y2 And x3>=Min(x1,x2) And x3<=Max(x1,x2) And Min(y3,y4)<=y1 And Max(y3,y4)=>y1 Then Return 1
If x1=x2 Then x1=x1+0.1
If x3=x4 Then x3=x3+0.1
Local m1# = (y1-y2)/(x1-x2)
Local m2# = (y3-y4)/(x3-x4)
Local c1# = y1 - m1 * x1
Local c2# = y3 - m2 * x3
If m1=m2 Then m1=m1+0.0001
Local x# = (c2 - c1) / (m1 - m2)
Local y# = x * m1 + c1
If Abs(x-x1)<=Abs(x1-x2) And Abs(x-x2)<=Abs(x1-x2) Then
If Abs(y-y1)<=Abs(y1-y2) And Abs(y-y2)<=Abs(y1-y2) Then
If Abs(x-x3)<=Abs(x3-x4) And Abs(x-x4)<=Abs(x3-x4) Then
If Abs(y-y3)<=Abs(y3-y4) And Abs(y-y4)<=Abs(y3-y4) Then
Return 1;End If;End If;End If;End If
End Function

Function CirclesCollide(x1,y1,r1,x2,y2,r2)
If Sqr((x2-x1)^2+(y2-y1)^2)<=r1+r2 Then Return 1
End Function

Function rectsoverlap(x0,y0,x1,y1,x2,y2,x3,y3)
If x0>x3 Or x1<x2 Then Return 0
If y0>y3 Or y1<y2 Then Return 0
Return 1
End Function

Function do_objects()
	For Local c:circle = EachIn circle_list
		c.draw()
		If c.moving = 1 Then c.move()
	Next
	For Local l:line = EachIn line_list
		l.draw()
		If l.moving = 1 Then l.move()
	Next
	For Local w:wheel = EachIn wheel_list
		If w.moving = 1 Then w.angleplus ; w.turn()
	Next
	For Local s:switch = EachIn switch_list
		s.draw()
		s.ctrl()
	Next
End Function


Function collisions()
	collided = 0
	
	For Local l:line = EachIn line_list
		If LinesCollide(l.x1,l.y1,l.x2,l.y2,px,py,px+30,py) Then newstart();Exit
		If LinesCollide(l.x1,l.y1,l.x2,l.y2,px,py,px,py+30) Then newstart();Exit
		If LinesCollide(l.x1,l.y1,l.x2,l.y2,px+30,py,px+30,py+30) Then newstart();Exit
		If LinesCollide(l.x1,l.y1,l.x2,l.y2,px,py+30,px+30,py+30) Then newstart();Exit
		
		If LinesCollide(l.x1,l.y1,l.x2,l.y2,px,py,old_px+30,old_py+30) Then newstart();Exit
		If LinesCollide(l.x1,l.y1,l.x2,l.y2,px+30,py,old_px,old_py+30) Then newstart();Exit
	Next
	
	If collided = 0 Then
		For Local c:circle = EachIn circle_list
			If CirclesCollide(px+15,py+15,15,c.x,c.y,c.r) Then newstart()
		Next
		
		If CirclesCollide(px+15,py+15,15,endx+15,endy+15,15) Then nlvl()
	End If
	
End Function

Function newstart()
collided = 1
lifes = lifes - 1
If lifes = 0 Then End
px = startx
py = starty
MoveMouse(startx,starty)
End Function

Function DrawXCenterText(t$,x,y)
	DrawText t$,(x+400-TextWidth(t$))/2,y
End Function

Function win()
	text$="Congratulations, you completed all levels!"
	t$=""
	u=0
	v=0
	
	FlushKeys()
	
	Repeat
		If u < Len(text$) Then v=v+1
		If v = 4 Then u=u+1 ; v=0
		t$=Mid(text$,1,u)
		DrawXCenterText t,400,300
		drawxcentertext "Press escape to end.",400,575
		
		WaitTimer timer
		Flip
		Cls
	Until KeyHit(KEY_ESCAPE)
	
	End
End Function

Function nlvl()
a_lvl=a_lvl+1;loadlevel(a_lvl)
End Function

'****************************************************************************************

Graphics 800,600,0
HideMouse()

Local ty#=160,tys#

a_lvl=1

Repeat
	
	ty#=ty#+tys#
	tys#=tys#+0.1
	If ty#>=160 Then tys#=-4
	
	DrawXCenterText "Skill Rabbit",400,ty#
	DrawXCenterText "Hit Enter to start!",400,250
	DrawXCenterText "Hit Escape to end.",400,350
	
	DrawLine 300,175,500,175
	
	WaitTimer timer
	Flip
	Cls
	
	If AppTerminate() Then End
	If KeyHit(KEY_ESCAPE) Then End
	If KeyHit(KEY_ENTER) Then Exit
	
Forever

loadlevel(a_lvl)
lifes = 10

'****************************************************************************************

Repeat
	
	mx = MouseX()
	my = MouseY()
	mh1= MouseHit(MOUSE_LEFT)
	
	DrawRect 1,1,800,600
	SetColor 0,0,0
	DrawRect 5,5,790,590
	SetColor 255,255,255
	
	If mx<6 Or mx>764 Or my<6 Or my>564 Then newstart()
	old_px=px
	old_py=py
	px = mx
	py = my
	
	do_objects()
	collisions()
	
	DrawImage rabbit,px,py
	DrawImage egg,endx,endy
	
	DrawText "Level " + a_lvl,10,10
	DrawText "Lifes: " + lifes,10,25
	
	WaitTimer timer
	Flip
	
	If AppTerminate() Then End
	If KeyHit(KEY_ESCAPE) Then End
	
	If KeyHit(KEY_TAB) Then nlvl()
	
Forever

'****************************************************************************************

End